/*****************************************************************************

		DCOMEXEC execute COM Task

		Author: FB.DRUILHE
		Update: Dec 15, 1989

******************************************************************************/


#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include "dcomstr.h"

#define FALSE 0
#define TRUE (!FALSE)

/*********************** External *******************************************/

/* Low Level com_acces */

extern void connect_it_com();
extern void disconnect_it_com();
extern char get_com(int i);
extern void write_com(int i, char c);
extern void flush_com_buff();

extern int  com_rx(int i);
extern int  com_tx(int i);
extern void com_break();
extern char tx_pattern(int ic);
extern char tx_set_pattern(int ic, int i_str);
extern void start_error_count(int ic);
extern void stop_error_count(int ic);
extern void count_error(int ic);
extern void screen_error(int ic);
extern int  setup_key(int c, char *title);
extern void choix_setup_tx();
extern void choix_setup_rx();
extern void affiche_time();
extern void confirm_exit();
extern int  affiche_choix( struct choix *c);
extern void open_error_window( int ic, int clr);
extern void close_error_window( int ic);

extern int com_port;
extern int com_overflow;
extern int end_prog;
extern int bip_on_err;

extern int run_single_test();

extern void select_setup();
extern int  setup_str( char *str, char *title);

extern int  put_screen(char c, int sc);
extern void clear_data_screen( int sc);
extern void init_screen();
extern void set_attribut_0(int i);
extern int  set_com_mode( char *st);

extern void sys_error( char *mes );
extern void title();

/*****************************************************************************/
char com_speed_str[2][12] = {     /* Command Setup */
     "9600 N81", "9600 N81" };

char user_speed_str[2][12] = {    /* User Setup */
     "9600 N81", "9600 N81" };

char *curr_speed_str[2] = { com_speed_str[0], com_speed_str[1] };

int  tx_source1=0;            /* source of Transmit char KeyBoard or Pattern */
int  rx_destination1=0;                 /* destination of the Received Chars */
int  tx_source2=0;            /* source of Transmit char KeyBoard or Pattern */
int  rx_destination2=0;                 /* destination of the Received Chars */

int  status_tempo=0;                             /* Temporisation for Status */
int  enable_status=TRUE;                              /* Enable MODEM Status */
int  zoom=FALSE;                                           /* Single display */

FILE *fintx;                     /* Input file for Tx */

#define TEMPO_STATUS 255

struct choix param_menu = {
	1, 4, FALSE,
	30, 3, 63, 8, TRUE,
	BLACK, WHITE, YELLOW,
	" COMMUNICATION PARAMETERS ",
	"Transmit Source      Alt-S",
	"Command Format       Alt-C",
	"User Format          Alt-U",
	"Receive Destination  Alt-D"
	};


/************************ Screen Management **********************************/
#define WINDOW_MAIN	1,5,80,25
#define WINDOW_MAIN_COLOR WHITE
#define WINDOW_MAIN_BACK  BLACK

void open_main_window(int clr)
{
	window(  WINDOW_MAIN );
	textbackground( WINDOW_MAIN_BACK );
	textcolor( WINDOW_MAIN_COLOR );
	window( 1, 1, 80, 25);
	if (clr)
	  {
	  int i;
	  init_screen();
	  clear_data_screen( 1 );
	  clear_data_screen( 2 );
	  }
}

/**************************** KeyBoard Managment *****************************/

#define MAXTX 255

char buff_tx[MAXTX+1];  /* Transmit Buffer */
extern char key[10][75];

char    get_tx_ch()
{
	char ct;
	int il,i;
	ct=buff_tx[0];
	il=strlen(buff_tx);
        if (il) for (i=0;i<=(il-1);i++) buff_tx[i]=buff_tx[i+1];
	buff_tx[il]=0;
	return(ct);
}

char	put_tx_ch( char c)
{
	int il,i;
	il=strlen(buff_tx);
	buff_tx[il]=c;
        if (il>=MAXTX)
	  {
	  for (i=0;i<=MAXTX;i++) buff_tx[i]=0;
	  cprintf("%c", 0x07);
	  }
}
/**************************** Hi Level Task **********************************/

void affiche_status( int i_clear)
{
	int i;
	char txstr[8][5] = { "QBF1", "QBF2", "File",
			     "AAAA", "UUUU", "", "",
			     "xxxx" };
	char rxstr[3][7] = { "Screen", "ErrCnt", "none  " };
	for (i=0;i<2;i++)
	  {
	  int j;
	  window(1, 1, 80, 25);
	  gotoxy(1+(40*i), 25);
	  if (i_clear) clreol();
	  if (com_port==(i+1))
	    {
	    textbackground( WHITE );
	    textcolor( BLACK );
	    }
	  else
	    {
	    textbackground( BLACK );
	    textcolor( WHITE );
	    }
	  cprintf(" COM%u: %s ",(i+1), curr_speed_str[i]);
	  read_com_status( (i+1), TRUE);
	  cprintf(" Tx:");
	  if (i==0) j=tx_source1;
	  else j=tx_source2;
	  if (j==0)
	    {
	    if (com_port==(i+1)) cprintf("Keyb ");
	    else cprintf("none ");
	    }
	  else cprintf("%s ", txstr[j-1]);
	  cprintf("Rx:");
	  if (i==0) j=rx_destination1;
	  else j=rx_destination2;
	  cprintf("%s ", rxstr[j]);
	  gotoxy(1, 1);
	  /* Error Count */
	  if (j==1)
	    {
	    open_error_window( i, FALSE );
	    screen_error( i );
	    window(1, 1, 80, 25);
	    }
	  }
}

void exec_status()
{
	if (!enable_status) return;
	if (status_tempo++>=TEMPO_STATUS)
	  {
	  affiche_status(0);
	  status_tempo=0;
	  }
}

void exec_com_tx(int ic)
{
	register char c;

	c=0;
	if (ic==1)
	  {
	  /* Check the Transmit Source */
	  if (!tx_source1)
	    {
	    if (com_port==1) c=get_tx_ch();
	    }
	  else
	    {
	    /* Predefined Pattern or Files */
	    if (tx_source1!=3) c=tx_pattern(1);
	    else
	      {
	      /* File */
	      c=getc(fintx);
	      if (c==EOF)
		{
		c=0;
		fclose(fintx);
		tx_source1=0;
		}
	      }
	    }
	  }
	else
	  {
	  /* Check the Transmit Source */
	  if (!tx_source2)
	    {
	    if (com_port==2) c=get_tx_ch();
	    }
	  else
	    {
	    /* Predefined Pattern or Files */
	    if (tx_source2!=3) c=tx_pattern(2);
	    else
	      {
	      /* File */
	      c=getc(fintx);
	      if (c==EOF)
		{
		c=0;
		fclose(fintx);
		tx_source2=0;
		}
	      }
	    }
	}
	/* Send Tx_Char if any */
	if (c)
	  {
	  write_com(ic, c);
	  }

	/* Execute Status Update */
	exec_status(0);
}

void exec_com_rx(int ic)
/* Execute Rx Task */
{
	/* Write char to CON */
	if (ic==1)
	  {
	  if (rx_destination1==0)
	    {
	    /* Screen */
	    if (zoom) put_screen(get_com(1), 0);
	    else put_screen(get_com(1), 1);
	    if (com_overflow)
	      {
	      sys_error("COMMUNICATION OVERFLOW");
	      com_overflow=FALSE;
	      flush_com_buff();
	      }
	    }
	  else if (rx_destination1==1) count_error(0) /* Error Count */;
	  else get_com(1);
	  }
	else
	  {
	  if (rx_destination2==0)
	    {
	    /* Screen */
	    if (zoom) put_screen(get_com(2), 0);
	    else put_screen(get_com(2), 2);
	    if (com_overflow)
	      {
	      sys_error("COMMUNICATION OVERFLOW");
	      com_overflow=FALSE;
	      flush_com_buff();
	      }
	    }
	  else if (rx_destination2==1) count_error(1) /* Error Count */;
	  else get_com(2) /* none */;
	  }
}

/************************ SETUP *****************************************/

void setup_tx(int v)
{
	int tx_source;
	int ic;
	ic = com_port;
	if (v)
	  {
	  tx_source=v-1; /* 0 is Keyboard */
	  if (tx_source==1) tx_set_pattern(ic, 1); /* QBF1 */
	  if (tx_source==2) tx_set_pattern(ic, 2); /* QBF2 */
	  if (tx_source==4) tx_set_pattern(ic, 3); /* AAAA */
	  if (tx_source==5) tx_set_pattern(ic, 4); /* UUUU */
	  if (tx_source==6) tx_set_pattern(ic, 5); /*  */
	  if (tx_source==7) tx_set_pattern(ic, 6); /*  */
	  if (tx_source==8) tx_set_pattern(ic, 7); /* xxxx */
	  if (tx_source==3)
	    { /* File */
	    if (setup_key(11, " Enter Transmit File Name "))
	      {
              fintx = fopen( key[10], "r");
	      if (fintx==NULL)
	        {
		tx_source=0;
		sys_error( "CANNOT OPEN FILE");
	        }
	      }
	    else tx_source=0;
	    }
	  if (com_port==1) tx_source1 = tx_source;
	  else tx_source2 = tx_source;
	  }
}

int previous_err_count[2] = { FALSE, FALSE };

void setup_rx(int v)
{
	if (v)
	  {
	  int ic;
	  ic=com_port-1;
	  if (ic==0) rx_destination1=v-1;
	  else rx_destination2=v-1;
	  if (previous_err_count[ic])
	    {
	    /* End of Error Count */
	    stop_error_count(ic);
	    previous_err_count[ic]=FALSE;
	    close_error_window(ic);
	    }

	  if ((v-1)==1)
	    {
	    /* Start of Error Count */
	    open_error_window( ic, TRUE );
	    start_error_count(ic);
	    previous_err_count[ic]=TRUE;
	    }
	  }
}

void setup_end_prog(int v)
{
	if (v) end_prog = v-1;
}

void setup_com_ports()
{
	int i;
	int cp=com_port;
	for (i=0;i<2;i++)
	  {
	  com_port=i+1;
	  set_com_mode( curr_speed_str[i]);
	  }
	com_port=cp;
}

int set_com_format( int ic, int com)
{
	int i;
	int cp=com_port;
	com_port=ic;
	if (com) i=set_com_mode( com_speed_str[ic-1]  );
	else     i=set_com_mode( user_speed_str[ic-1] );
	if (i)  sys_error("ILLEGAL FORMAT or SPEED");
	com_port=cp;
	return(i);
}
/*********************** EXEC_KEY *********************************/

void exec_key()
/*               Execution of the Main Menu */
{
	char c;
	/* is that a Command Function Key */
	c=getch();
	if (!c)
	  {
	  if (kbhit())
	    {
	    int ic;
	    c=getch();
	    ic = 0x00FF & c;

/* Alt 1..0     Expand String */
	    if (( ic>=120 )&&( ic<=130 ))
	      {
	      int j=ic-120;
	      int i=0;
	      char t;
	      if (ic==130) j=5 /* F6 */;
	      do {
		 t=key[j][i++];
		 if (t==94)
		   {
		   put_tx_ch((t=key[j][i++])-64);
		   }
		 else put_tx_ch(t);
		 } while (t);
	      }

/* Down or Left		Select COM1 Parameters */
	    if ((c==80)||(c==75))
	      {
	      com_port=1;
	      affiche_status( FALSE );
	      }

/* Up or Right		Select COM2 Parameters */
	    if ((c==72)||(c==77))
	      {
	      com_port=2;
	      affiche_status( FALSE );
	      }

/* Home		Help */
	    if (c==71)
	      {
	      title();
	      }

/* F1		Select Setup */
	    if (c==59)
	      {
	      int cp;
	      cp=com_port-1;
	      if (curr_speed_str[cp]==com_speed_str[cp])
		{
		if (!set_com_mode( user_speed_str[cp] ))
		  curr_speed_str[cp]=user_speed_str[cp];
		else sys_error("ILLEGAL COMMAND FORMAT");
		}
	      else
		{
		if (!set_com_mode( com_speed_str[cp] ))
		  curr_speed_str[cp]=com_speed_str[cp];
		else sys_error("ILLEGAL USER FORMAT");
		}
	      }

/* F2           Interpretor */
            if (c==60)
	      {
	      exec_interpretor();
	      }

/* F4		Break */
	    if (c==62)
	      {
	      com_break();
	      }
/* F5           Double Break */
	    if (c==63)
	      {
	      int sav=com_port;
	      for (com_port=1; com_port<=2; com_port++) com_break();
	      flush_com_buff();
	      com_port=sav;
	      }
/* F6           Bip_on_Error */
            if (c==64)
	      {
	      bip_on_err = !bip_on_err;
	      }
/* F9           Time */
	    if (c==67)
	      {
	      affiche_time();
	      }
/* F10		Main Menu */
	    if (c==68)
	      {
	      select_setup();
	      }
	    }

/* Alt P	Port Parameters */
	    if (c==25)
	      {
	      /* Tabulation ESC Alt-S Alt-C Alt-U Alt-D */
	      int ccc[5]= { 0, 31, 46, 22, 32 };
	      c=ccc[affiche_choix( &param_menu )];
	      }

/* Alt S        Setup_TX */
	    if (c==31)
	      {
	      choix_setup_tx();
	      }

/* Alt D        Setup_RX */
	    if (c==32)
	      {
	      choix_setup_rx();
	      }

/* Alt U        Set User Format */
	    if (c==22)
	      {
	      int cp;
	      setup_str( user_speed_str[com_port-1], " DEFINE USER FORMAT ");
	      cp=com_port-1;
	      if (curr_speed_str[cp]==user_speed_str[cp])
		{
		if (set_com_mode( user_speed_str[cp] ))
		  sys_error("ILLEGAL USER FORMAT");
		}
	      }
/* Alt C        Set Command Format */
	    if (c==46)
	      {
	      int cp;
	      setup_str( com_speed_str[com_port-1], " DEFINE COMMAND FORMAT ");
	      cp=com_port-1;
	      if (curr_speed_str[cp]==com_speed_str[cp])
		{
		if (set_com_mode( com_speed_str[cp] ))
		  sys_error("ILLEGAL COMMAND FORMAT");
		}
	      }

/* Alt A        Run Test */
	    if (c==30)
	      {
	      run_single_test();
	      /* Return is COMMAND Mode */
	      curr_speed_str[0]=com_speed_str[0];
	      curr_speed_str[1]=com_speed_str[1];
	      }

/* Alt X        Exit     */
	    if (c==45)
	      {
	      confirm_exit();
	      }

/* Alt Z        Zoon     */
	    if (c==44)
	      {
	      if (!zoom)
		{
		set_attribut_0( com_port );
		clear_data_screen( 0 );
		if (com_port==1) rx_destination2=2 /* none */;
		else rx_destination1=2 /* none */;
		}
	      else
		{
		clear_data_screen( 1 );
		clear_data_screen( 2 );
		rx_destination1=0 /* Screen */;
		rx_destination2=0 /* Screen */;
		}
	      zoom=(!zoom);
	      }


	    exec_status(1);
	  }
	else
	  put_tx_ch(c);
}

