/*******************************************************************

	     DCOM_IT   Interrupt Management of a Both COM Port

	 	Author: FB.DRUILHE
		Date:   February 07, 1990

********************************************************************/

#include <dos.h>
#include <stdio.h>
#include <conio.h>

/****************** IT Variables Declaration ***********************/
#define BUFF_MOD 0xFF
#define BUFF_SIZE (BUFF_MOD+1)

int com_port=1;                   /* Communication Register 1 or 2 */

#define COM1_RX_READY (com_num1!=0)
char com_buff1[BUFF_SIZE];             /* Received Caracters Buffer */
int com_num1;                     /* Current contain of the Buffer */
void interrupt (*old_it1)();    /* Old value of the IT_COM1 vector */
#define COM2_RX_READY (com_num2!=0)
char com_buff2[BUFF_SIZE];             /* Received Caracters Buffer */
int com_num2;                     /* Current contain of the Buffer */
void interrupt (*old_it2)();    /* Old value of the IT_COM2 vector */

struct REGPACK regs;                /* General Purpose REGS for IT */

int com_overflow=0;                      /* Communication Overflow */

/******************* Send Automatic Patterns ***********************/
char *QBF_STR1 =
      "\nTHE QUICK BROWN FOX JUMPS OVER THE LAZY DOG 0123456789\x0D";
char *QBF_STR2 =
      "\nthe quick brown fox jumps over the lazy dog 9876543210\x0D";

char *curr_qbf_pnt1;                           /* Transmit Pointer */
char single_char1;                              /* Send Sigle Char */
int  qbf_str1;                               /* Begining of String */

char *curr_qbf_pnt2;                           /* Transmit Pointer */
char single_char2;                              /* Send Sigle Char */
int  qbf_str2;                               /* Begining of String */

/******************* Receive Automatic Patterns ********************/
char *curr_rx_pnt[2];           /* Receive Pointer for Error Count */
long int  pat_err[2];                   /* number of erronous char */
long int  pat_rx[2];                    /* number or received char */
int  pat_sync[2];                                 /* Error Synchro */

int  bip_on_err=1;                                 /* Bip on Error */
int  need_to_bip=0;                                    /* Send Bip */

void interrupt it_com1()
{
	/* Store Caracter */
	disable();
	/* if ((inportb(0x3FA)&0x6)==0x4)   */
	  com_buff1[com_num1++] = inportb(0x3F8);
        /* Return from IT */
	outportb( 0x20, 0x24 );
	enable();
	if (com_num1 >= BUFF_SIZE)
	  {
	  com_overflow= 1;
	  com_num1 = 0 /* BUFF_MOD */;
	  }
}

void interrupt it_com2()
{
	/* Store Caracter */
	disable();
	/* if ((inportb(0x2FA)&0x6)==0x4) */
	  com_buff2[com_num2++] = inportb(0x2F8);
        /* Return from IT */
	outportb( 0x20, 0x23 );
	enable();
	if (com_num2 >= BUFF_SIZE)
	  {
	  com_overflow= 1;
	  com_num2 = 0 /* BUFF_MOD */;
	  }
}
void enable_it_com()
{
	  /* Enable IT */
	  disable();
	  outportb(0x3FC, 0x0D);
	  outportb(0x3F9, 0x01);
	  /* Enable IT for i8259A */
          outportb(0x21, (inportb(0x21) & 0xEF));

	  outportb(0x2FC, 0x0D);
	  outportb(0x2F9, 0x01);
	  /* Enable IT for i8259A */
          outportb(0x21, (inportb(0x21) & 0xF7));
	  enable();
}

void connect_it_com()
{
	/* Disable IT for i8259A */
	disable();
        outportb(0x21, (inportb(0x21) | 0x18));
	enable();
	/* Clear Buffer */
	com_num1 = 0;
	com_num2 = 0;
	/* Connect ITs Vectors */
	old_it1 = getvect(0x0C);
	setvect(0x0C, it_com1);
	old_it2 = getvect(0x0B);
	setvect(0x0B, it_com2);

	/* enable ITs */
	enable_it_com();
}

void disconnect_it_com()
{
	setvect(0x0C, old_it1);
	setvect(0x0B, old_it2);
	/* Disable IT for i8259A */
	disable();
        outportb(0x21, (inportb(0x21) | 0x18));
	/* Disable IT for i8250 */
	outportb(0x2F9, 0x00);
	outportb(0x3F9, 0x00);
	enable();
}

void com_break()
{
	int addr;
	addr=((com_port-1) ? 0x2FC : 0x3FC);
	outportb(addr, (inportb(addr) & 0xFE));
	delay(1000);
        outportb(addr, (inportb(addr) | 0x01));
}

int com_tx(int ic)
{
	if (ic==1) return((inportb(0x3FD)&0x20));
	else return((inportb(0x2FD)&0x20));
}

int com_rx(int ic)
{
	if (ic==1) return(com_num1);
	else return(com_num2);
}

void flush_com_buff()
{
	com_num1 = 0;
	com_num2 = 0;
	com_overflow = 0;
}

char get_com(int ic)
{
	register char com_ch;
	if (ic==1)
	  {
	  disable();
	  com_ch = com_buff1[0];
	  com_num1--;
	  movmem(&com_buff1[1], &com_buff1[0], com_num1);
	  enable();
	  }
	else
	  {
	  disable();
	  com_ch = com_buff2[0];
	  com_num2--;
	  movmem(&com_buff2[1], &com_buff2[0], com_num2);
	  enable();
	  }
	return(com_ch);
}

void write_com( int ic, char ch )
{
	while (!com_tx(ic)) /* Wait */;
	if (ic==1) outportb(0x3F8, ch);
	else  outportb(0x2F8, ch);
}

int read_com_status( int ic, int pr)
{
	int r;

	r = inportb(((ic-1) ? 0x2FE : 0x3FE));
	if (pr)
	  {
	  if (r&0x80) cprintf("C"); else cprintf("c");
	  if (r&0x40) cprintf("R"); else cprintf("r");
	  if (r&0x20) cprintf("D"); else cprintf("d");
	  if (r&0x10) cprintf("S"); else cprintf("s");
	  }
	return( r );
}

void tx_set_pattern(int ic, int i_str)
{
	if (ic==1)
	  {
	  single_char1 = 0;
	  if (i_str==1) curr_qbf_pnt1 = QBF_STR1;
	  else if (i_str==2) curr_qbf_pnt1 = QBF_STR2;
	  else if (i_str==3) single_char1 = 'A';
	  else if (i_str==4) single_char1 = 'U';
	  else if (i_str==5) single_char1 = '';
	  else if (i_str==6) single_char1 = '';
	  else if (i_str==7) single_char1 = 'x';
	  qbf_str1 = i_str;
	  }
	else
	  {
	  single_char2 = 0;
	  if (i_str==1) curr_qbf_pnt2 = QBF_STR1;
	  else if (i_str==2) curr_qbf_pnt2 = QBF_STR2;
	  else if (i_str==3) single_char2 = 'A';
	  else if (i_str==4) single_char2 = 'U';
	  else if (i_str==5) single_char2 = '';
	  else if (i_str==6) single_char2 = '';
	  else if (i_str==7) single_char2 = 'x';
	  qbf_str2 = i_str;
	  }
}

char tx_pattern(int ic)
{
	char c;
	if (ic==1)
	  {
	  if (single_char1) return(single_char1);
	  c=*curr_qbf_pnt1++;
	  if (c==0x0D) tx_set_pattern(1, qbf_str1);
	  return(c);
	  }
	 else
	  {
	  if (single_char2) return(single_char2);
	  c=*curr_qbf_pnt2++;
	  if (c==0x0D) tx_set_pattern(2, qbf_str2);
	  return(c);
	  }
}

void start_error_count(int ic)
{
	pat_err[ic]=0;
	pat_rx[ic]=0;
	pat_sync[ic]=0;
	need_to_bip=0;
	/* cprintf("\n\nStart Rx Pattern\n");  */
}

void stop_error_count(int ic)
{
	pat_sync[ic]=0;
	/* cprintf(" Errors = %ld,    RxChar = %ld\n\n",pat_err,pat_rx); */
}

void screen_error(int ic)
/* Count Errors */
{
	if (pat_sync[ic])
	  {
	  cprintf("RxError = %10ld,  RxChar = %10ld ",pat_err[ic],pat_rx[ic]);
	  if (bip_on_err)
	    {
	    cprintf("");
	    if (need_to_bip) putch( 0x07 );
	    }
	  else cprintf(" ");
	  }
	else
	  cprintf("Waiting Synchro");
       /* Reset Bip Flag */
       need_to_bip=0;

}

void count_error(int ic)
{
        register char c;
	c=get_com(ic+1);
	/* putchar(c); */
	if (pat_sync[ic])
	  {
	  char cQBF;
	  /* Check Loose of Synchronisation */
	  if (pat_sync[ic]>0)
	    {
	    /* No loose */
	    pat_rx[ic]++;
	    cQBF=*curr_rx_pnt[ic]++;
	    if (cQBF!=c)
	      {
	      /* cprintf("[%d %d]", c, cQBF); delay(1000); */
	      need_to_bip=1;
	      pat_err[ic]++;
	      pat_sync[ic]++;
	      if (pat_sync[ic]==17)
		{
		/* Loose of Synchronisation */
		pat_sync[ic]=-1;
		}
	      }
	    else pat_sync[ic]=1;
	    if (cQBF==0x0D) curr_rx_pnt[ic]=QBF_STR1;
	    }
	  else
	    {
	    /* Loose */
	    if (c==0x0D) pat_sync[ic]=1;
	    curr_rx_pnt[ic]=QBF_STR1;
	    }
	  }
	else
	  {
	  /* Wait until x0D */
	  pat_sync[ic]=0;
	  if (c==0x0D) pat_sync[ic]=1;
	  curr_rx_pnt[ic]=QBF_STR1;
	  }
	if (com_overflow)
	  {
	  stop_error_count(ic);
	  /* sys_error("COMMUNICATION OVERFLOW"); */
	  flush_com_buff();
	  pat_sync[0]=0;
	  pat_sync[1]=0;
	  }
}

int set_com_mode( char *str )
/* Set Com Port Format According with a String */
{
	int l, s, ifo;
	unsigned int is;
	double speed, clk=115200.0 /* 1843200.0 */;
	char ch;

	/* Get Speed, Parity, Length, Stop */
	if (sscanf(str, "%lf %c%1u%1u", &speed, &ch, &l, &s)!=4) return(2);
	/* Check Parameters */
	if ((speed<=0)||(speed>20000)) return(1);
	is = (unsigned int) (clk/speed);
	/* Parity */
	if      (ch=='N') ifo= 0;
	else if (ch=='E') ifo= 0x0018;
	else if (ch=='O') ifo= 0x0008;
	else if (ch=='M') ifo= 0x0038;
	else if (ch=='S') ifo= 0x0028;
	else return(1);
	/* Lenght */
	if      (l==5)    ifo|=0;
	else if (l==6)    ifo|=1;
	else if (l==7)    ifo|=2;
	else if (l==8)    ifo|=3;
	else return(1);
	/* Stop */
	if      (s==1)    ifo|=0;
	else if (s==2)    ifo|=4;
	else return(1);

	  {
	  int addr;
	  addr=((com_port-1) ? 0x2FB : 0x3FB);
	  disable();
	  /* Write Speed */
	  outportb(addr, (inportb(addr) | 0x80)); /* Set DLAB to 1 */
	  outport((addr-3), is);
	  /* Write Format */
	  outportb(addr, (unsigned char) (ifo & 0x003F));
	  enable();
	  }

	return(0);
}